package com.jiuqi.db.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.db.DBFunction;
import com.jiuqi.util.DateUtil;
import java.util.Date;

public class OracleDBFunction extends DBFunction {
  private static final String STR_LINK_SYMBOL = "||";
  
  private static final String FUNC_NAME_CEILING = "CEIL";
  
  private static final String FUNC_NAME_LN = "LN";
  
  private static final String FUNC_NAME_LOG10 = "LOG";
  
  private static final String FUNC_NAME_CHR = "CHR";
  
  private static final String FUNC_NAME_POS = "INSTR";
  
  private static final String FUNC_NAME_LEFT = "SUBSTRB";
  
  private static final String FUNC_NAME_RIGHT = "SUBSTRB";
  
  private static final String FUNC_NAME_SUBSTR = "SUBSTRB";
  
  private static final String FUNC_NAME_LEN = "LENGTH";
  
  private static final String FUNC_NAME_MOD = "MOD";
  
  private static final String FUNC_NAME_STR = "TO_CHAR";
  
  private static final String FUNC_NAME_VAL = "TO_NUMBER";
  
  private static final String FUNC_NAME_DATE = "TO_DATE";
  
  public String strLinkSymbol() {
    return "||";
  }
  
  public boolean supportEmptyString() {
    return false;
  }
  
  public String ceiling(String numeric_expression) {
    return format("CEIL", numeric_expression);
  }
  
  public String ln(String numeric_expression) {
    return format("LN", numeric_expression);
  }
  
  public String log10(String numeric_expression) {
    return format("LOG", numeric_expression, "10");
  }
  
  public String mod(String numeric_expression1, String numeric_expression2) {
    return format("MOD", numeric_expression1, numeric_expression2);
  }
  
  public String chr(String int_expression) {
    return format("CHR", int_expression);
  }
  
  public String pos(String substr_expression, String str_expression) {
    return format("INSTR", str_expression, substr_expression);
  }
  
  public String left(String str_expression, String length_expression) {
    return format("SUBSTRB", str_expression, "1", length_expression);
  }
  
  public String right(String str_expression, String length_expression) {
    return format("SUBSTRB", str_expression, formatmidopt(len(str_expression), "-", String.valueOf(length_expression) + "+1"), length_expression);
  }
  
  public String str(String numeric_expression) {
    return format("TO_CHAR", numeric_expression);
  }
  
  public String substr(String str_expression, String from_expression, String length_expression) {
    return format("SUBSTRB", str_expression, from_expression, length_expression);
  }
  
  public String len(String str_expression) {
    return format("LENGTH", str_expression);
  }
  
  public String val(String str_expression) {
    return format("TO_NUMBER", str_expression);
  }
  
  public String date(Date dateVal) {
    StringBuffer sql = new StringBuffer();
    sql.append("TO_DATE");
    sql.append("('");
    sql.append(DateUtil.convertDateToString1(dateVal));
    sql.append("','yyyy-MM-dd')");
    return sql.toString();
  }
}
